// Winston Salem Traffic Cameras
// Widget version 1.0

	var changeIndex = 1;
        var version   = 1.0; 
        var index     = -1;
        var sinceUpdate = 0;
        var webProxy  = "";

        var cameras = new Array();
        
        cameras['All Cameras']     = new Array();
        cameras['All Cameras'][0]  = '"http://www.ikk-hamburg.de/seiten/webcam/bild.php?bild=klein"|A7 Stellingen Richtung Sueden'
        cameras['All Cameras'][1]  = '"http://www.radiohamburg.de/extdaten/webcam/cam1_michel.jpg?1128881927"|Blick vom Michel'
        cameras['All Cameras'][2]  = '"http://www.radiohamburg.de/extdaten/webcam/petri.jpg?1128883789"|Blick von der Petri-Kirche'
        cameras['All Cameras'][3]  = '"http://www.dwd.de/ext/e4/wkam1-10148.jpg"|Hafen'
        cameras['All Cameras'][4]  = '"http://www2.philips.de/webbild/fullsize.jpg"|Aussenalster'
        cameras['All Cameras'][5]  = '"http://alster.unilever.com/actpict.jpg"|Binnen- und Aussenalster (von Unilever)'
        cameras['All Cameras'][6]  = '"http://www.hafen-hamburg.de/webcam/camstill.jpg"|Neuhof'


        function prevIndex()
        {
            index = index - 1;

            if (index &lt; 0)
                index = cameras[preferences.location.value].length - 1;

			updateCamera();
        }

        function nextIndex()
        {
            index = index + 1;

            if (index &gt; cameras[preferences.location.value].length - 1)
	        index = 0;

			updateCamera();
        }

		function pauseIndex()
		{
			changeIndex = (changeIndex == 0) ? 1 : 0;

			if (changeIndex == 1)
				pauseTitle.data = "";
			else
				pauseTitle.data = "PAUSED";

			pauseShadow.data = pauseTitle.data;
        }

        function updateCamera() 
        {
            var cacheFile;
            print('Fetching cameras for '+preferences.location.value);
            
            imgInfo = cameras[preferences.location.value][index].split(/\|/);
            
            cacheFile = "Cache/cache.jpg";
            
            if (preferences.webProxy.value != "")
                webProxy = "-x " + preferences.webProxy.value;

            var getImage = "curl " + webProxy + " --silent " + imgInfo[0]
                    + " --max-time 300 -w \"%{http_code}\\n\" --output " 
                    + cacheFile;

            print("Show  : " + index);
            print("Run   : " + getImage);
            print("Cache : " + cacheFile);

            var result = runCommand(getImage);
            print("Returned : " + result);

            displayFile = cacheFile;

            // Change text to reflect the changed image
            imageTitle.data = imgInfo[1];
            imageTitleShadow.data = imgInfo[1];
            
            // Fade between the images
            fadeImage.vOffset = 26;
            fadeImage.hOffset = 0;
            fadeImage.opacity = 0;
            fadeImage.src = cacheFile;
            fadeImage.reload();
            fadeImage.fade(fadeImage.opacity, 255, 1);
            cameraImage.fade(cameraImage.opacity, 0, 1);
            
            // Reset cameraImage to be the 'main' image holder
            cameraImage.vOffset = 26;
            cameraImage.hOffset = 0;
            cameraImage.src = fadeImage.src;
            cameraImage.reload();
            cameraImage.opacity = 255;
            
            sinceUpdate = 0;
        }
        
        function updateSize() 
        {
            suppressUpdates();
            
            print("Value: "+preferences.imageSize.value);
            if (preferences.imageSize.value == "256x192")
            {
				width = 256; height = 192;
            }
            else if (preferences.imageSize.value == "384x288")
            {
				width = 384; height = 288;
            }
            else if (preferences.imageSize.value == "448x336")
            {
				width = 448; height = 336;
            }
            else if (preferences.imageSize.value == "512x384")
            {
				width = 512; height = 384;
            }
            else if (preferences.imageSize.value == "576x432")
            {
				width = 576; height = 432;
            }
            else if (preferences.imageSize.value == "640x480")
            {
				width = 640; height = 480;
            }
            else
            {
				width = 319; height = 239;
		// This is not set for exactly 320x240 because of the 'image loads half way' problem that occurs
		// when the source image size is the exact dimension of your image size preference.
	    }
            
            print("W:"+width+" H:"+height);
            
            mainWindow.width = width;
            mainWindow.height = height+25;
            
            top.width = width;

            fadeImage.vOffset = 26;
            fadeImage.hOffset = 0;
            fadeImage.width  = cameraImage.width = width;
            fadeImage.height = cameraImage.height = height;

            imageTitle.vOffset = 17;
            imageTitle.hOffset = fadeImage.width - 25;
            
            imageTitleShadow.vOffset = imageTitle.vOffset + 1;
            imageTitleShadow.hOffset = imageTitle.hOffset + 1;
            
            pauseTitle.vOffset = imageTitle.vOffset;
            pauseTitle.hOffset = 55;

            pauseShadow.vOffset = pauseTitle.vOffset + 1;
            pauseShadow.hOffset = pauseTitle.hOffset + 1;

            nextImage.vOffset = 5;
            nextImage.hOffset = fadeImage.width - 20;
            
            resumeUpdates();
            updateNow();
        }

        updateSize();
        mainWindow.visible = true;
		nextIndex();
